// OPN2001_DEMODlg.cpp : implementation file
//

#include "stdafx.h"
#include "OPN2001_DEMO.h"
#include "OPN2001_DEMODlg.h"
#include "csp2.h"		// csp2 dll header files
#include "SerialEnum.h" // serial port enumerator
#include <dbt.h>
#include <shlwapi.h>
#include "DlgParameters.h"
#include "INIFILE.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#endif

bool firstLoad = true;
bool firstAutoLoad = true;
WCHAR szModulePath[ 1024 + 1];
CString strCurSavePath;
CString strCurSaveFileName;
CString gszFormattedDeviceID;

void *COPN2001_DEMODlg::pDlgObject;

using namespace std; // needed for list

    enum symbologie
    {
        Bookland = 0x16,
        Codabar = 0x02,
        Code_11 = 0x0c,
        Code_32 = 0x20,
        Code_128 = 0x03,
        Code_39 = 0x01,
        Code_39_Full_ASCII = 0x13,
        Code_93 = 0x07,
        Composite = 0x1d,
        Coupon = 0x17,
        D25 = 0x04,
        Data_Matrix = 0x1b,
        EAN_128 = 0x0f,
        EAN_13 = 0x0b,
        EAN_13_2 = 0x4b,
        EAN_13_5 = 0x8b,
        EAN_8 = 0x0a,
        EAN_8_2 = 0x4a,
        EAN_8_5 = 0x8a,
        IATA = 0x05,
        ISBT_128 = 0x19,
        ISBT_128_concatenated = 0x21,
        ITF = 0x06,
        Macro_PDF = 0x28,
        MSI = 0x0E,
        PDF_417 = 0x11,
        Postbar_Canada = 0x26,
        Postnet_US = 0x1e,
        Postal_Australia = 0x23,
        Postal_Japan = 0x22,
        Postal_UK = 0x27,
        QR_code = 0x1c,
        RSS_limited = 0x31,
        RSS_14 = 0x30,
        RSS_Expanded = 0x32,
        Signature = 0x24,
        Trioptic_Code_39 = 0x15,
        UPCA = 0x08,
        UPCA_2 = 0x48,
        UPCA_5 = 0x88,
        UPCE = 0x09,
        UPCE_2 = 0x49,
        UPCE_5 = 0x89,
        UPCE1 = 0x10,
        UPCE1_2 = 0x50,
        UPCE1_5 = 0x90
    };

	const SBCD_DEFS bcodedefs[] = 
	{
        L"Bookland",	Bookland,
        L"Codabar",		Codabar,
        L"Code-11",		Code_11,
		L"Code-32",		Code_32,
        L"Code-128",	Code_128,
		L"Code-39",		Code_39,
        L"Code-39 full ASCII", Code_39_Full_ASCII,
        L"Code-93",		Code_93,
        L"Composite",	Composite,
        L"Coupon",		Coupon,
        L"D 2 of 5",	D25,
        L"Data Matrix", Data_Matrix,
        L"EAN-128",		EAN_128,
        L"EAN-13",		EAN_13,
        L"EAN-13 + 2",	EAN_13_2,
        L"EAN-13 + 5",	EAN_13_5,
        L"EAN-8",		EAN_8,
        L"EAN-8 + 2",	EAN_8_2,
        L"EAN-8 + 5",	EAN_8_5,
        L"IATA",		IATA,
        L"ISBT-128",	ISBT_128,
        L"ISBT-128 concatenated", ISBT_128_concatenated,
        L"ITF",			ITF,
		L"Macro PDF",	Macro_PDF,
        L"MSI",			MSI,
        L"PDF-417",		PDF_417,
        L"Postbar (Canada)", Postbar_Canada,
        L"Postnet (US)",Postnet_US,
        L"Postal (Australia)",	Postal_Australia,
        L"Postal (Japan)",	Postal_Japan,
        L"Postal (UK)",	Postal_UK,
        L"QR-code",		QR_code,
        L"RSS-limited",	RSS_limited,
        L"RSS-14",		RSS_14,
        L"RSS-expanded",RSS_Expanded,
        L"Signature",	Signature,
        L"Tri-Optic",	Trioptic_Code_39,
        L"UPC-A",		UPCA,
        L"UPC-A + 2",	UPCA_2,
        L"UPC-A + 5",	UPCA_5,
        L"UPC-E",		UPCE,
        L"UPC-E + 2",	UPCE_2,
        L"UPC-E + 5",	UPCE_5,
        L"UPC-E1",		UPCE1,
        L"UPC-E1 + 2",	UPCE1_2,
        L"UPC-E1 + 5",	UPCE1_5
	};
#define MAX_BCD		( sizeof(bcodedefs) / sizeof(SBCD_DEFS))

// CAboutDlg dialog used for App About
class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// COPN2001_DEMODlg dialog




COPN2001_DEMODlg::COPN2001_DEMODlg(CWnd* pParent /*=NULL*/)
	: CDialog(COPN2001_DEMODlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_nUsedPort = 0; //	COM1

	m_bAutoNotClicked = FALSE;
}

void COPN2001_DEMODlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_CMBO_PORT, m_cmboPort);
	DDX_Control(pDX, IDC_BTN_OPEN, m_btnOpen);
	DDX_Control(pDX, IDC_BTN_CLOSE, m_btnClose);
	DDX_Control(pDX, IDC_STAT_DLL_VERSION, m_statDllVersion);
	DDX_Control(pDX, IDC_STAT_OS_VERSION, m_statOSVersion);
	DDX_Control(pDX, IDC_STAT_ID, m_statID);
	DDX_Control(pDX, IDC_CHECK_AUTO, m_btnAuto);
	DDX_Control(pDX, IDC_LIST_BCD_DATA, m_listBcdData);
	DDX_Control(pDX, IDC_CHECK_SYMBOLOGY, m_checkSymbology);
	DDX_Control(pDX, IDC_CHECK_TIME, m_checkTime);
	DDX_Control(pDX, IDC_CHECK_DATE, m_checkDate);
	DDX_Control(pDX, IDC_CHECK_SERIAL, m_checkSerial);
	DDX_Control(pDX, IDC_RADIO_FORMAT_TEXT, m_radioText);
	DDX_Control(pDX, IDC_RADIO_FORMAT_CSV, m_radioCSV);
	DDX_Control(pDX, IDC_COMBO_DELIMETER, m_cmboDelimeter);
	DDX_Control(pDX, IDC_RADIO_TIME_12, m_radiot12);
	DDX_Control(pDX, IDC_RADIO_TIME_24, m_radiot24);
	DDX_Control(pDX, IDC_RADIO_DATE_USA, m_radiodUSA);
	DDX_Control(pDX, IDC_RADIO_DATE_EU, m_radiodEU);
	DDX_Control(pDX, IDC_RADIO_DATE_LONG, m_radiodLong);
}
BEGIN_MESSAGE_MAP(COPN2001_DEMODlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_CBN_SELCHANGE(IDC_CMBO_PORT, &COPN2001_DEMODlg::OnCbnSelchangeCmboPort)
	ON_BN_CLICKED(IDC_BTN_OPEN, &COPN2001_DEMODlg::OnBnClickedBtnOpen)
	ON_BN_CLICKED(IDC_BTN_CLOSE, &COPN2001_DEMODlg::OnBnClickedBtnClose)
	ON_BN_CLICKED(IDC_BTN_INTERROGATE, &COPN2001_DEMODlg::OnBnClickedBtnInterrogate)
	ON_MESSAGE( WM_DEVICECHANGE, &COPN2001_DEMODlg::OnDeviceChange )
	ON_BN_CLICKED(IDC_BTN_GET_TIME, &COPN2001_DEMODlg::OnBnClickedBtnGetTime)
	ON_BN_CLICKED(IDC_BTN_SET_TIME, &COPN2001_DEMODlg::OnBnClickedBtnSetTime)
	ON_BN_CLICKED(IDC_CHECK_AUTO, &COPN2001_DEMODlg::OnBnClickedCheckAuto)
	ON_BN_CLICKED(IDC_BTN_GET_BARCODE, &COPN2001_DEMODlg::OnBnClickedBtnGetBarcode)
	ON_BN_CLICKED(IDC_BTN_CLEAR_BARCODE, &COPN2001_DEMODlg::OnBnClickedBtnClearBarcode)
	ON_BN_CLICKED(IDC_BTN_PARAMETERS, &COPN2001_DEMODlg::OnBnClickedBtnParameters)
	ON_BN_CLICKED(IDC_CHECK_SAVE, &COPN2001_DEMODlg::OnBnClickedCheckSave)
	ON_WM_CLOSE()
	ON_BN_CLICKED(IDC_BTN_ABOUT, &COPN2001_DEMODlg::OnBnClickedBtnAbout)
	ON_BN_CLICKED(IDC_CHECK_SYMBOLOGY, &COPN2001_DEMODlg::OnBnClickedCheckSymbology)
	ON_BN_CLICKED(IDC_CHECK_TIME, &COPN2001_DEMODlg::OnBnClickedCheckTime)
	ON_BN_CLICKED(IDC_CHECK_DATE, &COPN2001_DEMODlg::OnBnClickedCheckDate)
	ON_BN_CLICKED(IDC_RADIO_FORMAT_TEXT, &COPN2001_DEMODlg::OnBnClickedRadioFormatText)
	ON_BN_CLICKED(IDC_RADIO_FORMAT_CSV, &COPN2001_DEMODlg::OnBnClickedRadioFormatCSV)
	ON_BN_CLICKED(IDC_RADIO_TIME_12, &COPN2001_DEMODlg::OnBnClickedRadioTime12)
	ON_BN_CLICKED(IDC_RADIO_TIME_24, &COPN2001_DEMODlg::OnBnClickedRadioTime24)
	ON_BN_CLICKED(IDC_RADIO_DATE_USA, &COPN2001_DEMODlg::OnBnClickedRadioDateUSA)
	ON_BN_CLICKED(IDC_RADIO_DATE_EU, &COPN2001_DEMODlg::OnBnClickedRadioDateEU)
	ON_BN_CLICKED(IDC_RADIO_DATE_LONG, &COPN2001_DEMODlg::OnBnClickedRadioDateLong)
	ON_CBN_SELCHANGE(IDC_COMBO_DELIMETER, &COPN2001_DEMODlg::OnCbnSelChangeComboDelimeter)
//	ON_CBN_EDITUPDATE(IDC_COMBO_DELIMETER, &COPN2001_DEMODlg::OnCbnEditUpdateComboDelimeter)
	ON_BN_CLICKED(IDC_BTN_BROWSE, &COPN2001_DEMODlg::OnBnClickedBtnBrowse)
	ON_BN_CLICKED(IDC_SHOW_ALL, &COPN2001_DEMODlg::OnBnClickedShowAll)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_CHECK_SERIAL, &COPN2001_DEMODlg::OnBnClickedCheckSerial)
END_MESSAGE_MAP()


// COPN2001_DEMODlg message handlers

BOOL COPN2001_DEMODlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	pDlgObject = this;

	// First find the available serial ports
	//CSerialEnum::GetSerialPorts2( m_nPortArray );

	GetModuleFileName( AfxGetInstanceHandle(), szModulePath, 1024 );
	PathRemoveFileSpec( szModulePath );
	
	m_strConfigFile = szModulePath;
	m_strConfigFile += _T("\\OPN_APPL.INI");

	CIniFile iniOpnDemo;
	iniOpnDemo.SetPathName( m_strConfigFile );

	//m_nUsedPort = iniOpnDemo.ReadInt( L"GLOBAL", L"USED_PORT", 0); 
	m_bComOpen = FALSE;
	m_bSaveToFile = iniOpnDemo.ReadBool( L"GLOBAL", L"SAVEFILE", FALSE); 
	m_bAuto = iniOpnDemo.ReadBool( L"GLOBAL", L"AUTO", FALSE); 
	m_bShowAll = iniOpnDemo.ReadBool( L"GLOBAL", L"SHOWALL", FALSE); 

	InitComboBox();
	InitFormatControls();

	char szVersion[ 20 + 1];
	CString strVersion;
	csp2GetDllVersion( szVersion, 20 );
	strVersion.Format( _T("%S"), szVersion );
	m_statDllVersion.SetWindowText( strVersion );
	
	CButton *pBtn;
	
	pBtn = (CButton*)GetDlgItem( IDC_CHECK_SAVE );
	pBtn->SetCheck( m_bSaveToFile );

	pBtn = (CButton*)GetDlgItem( IDC_SHOW_ALL );
	pBtn->SetCheck( m_bShowAll );
	pBtn->EnableWindow( FALSE );

	m_btnAuto.SetCheck( m_bAuto );

	if( m_nUsedPort != 0 ) //Added so open will be attempted when a port number is read from the ini file which indicates not a first run.
	{
		firstLoad = false;
	}
	// Now try to open the port
	OnBnClickedBtnOpen();
	firstAutoLoad = false;

	SetTimer(NULL, 500, NULL);

	if(m_bComOpen == FALSE && m_bShowAll == FALSE)		// If no OPN2001 is connected by USB or the comport could not be opened
	{													// make sure that the 'show all' option is available.
		pBtn->EnableWindow( TRUE );
	}
#ifdef WIN64_DLL
	this->SetWindowTextW(L"OPN2001(x64)");
#endif

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void COPN2001_DEMODlg::InitComboBox()
{
	CIniFile iniOpnDemo;
	iniOpnDemo.SetPathName( m_strConfigFile );

	// First find the available serial ports
	CSerialEnum::GetOPN01ConnectedSerialPorts( m_nPortArray, m_bShowAll );
	m_nUsedPort = iniOpnDemo.ReadInt( L"GLOBAL", L"USED_PORT", 0); 
	m_nPortArray.sort();
	// Fill the combobox
	m_cmboPort.ResetContent(); // Clear the list in the combobox;
	CString strPort;
	int x;
	for( m_itPorts = m_nPortArray.begin(), x = 0; m_itPorts != m_nPortArray.end(); m_itPorts++, x++ )
	{
		strPort.Format(_T("COM%d"), *m_itPorts );
		m_cmboPort.AddString( strPort );
		m_cmboPort.SetItemData( x, *m_itPorts );
	}
	if( m_nUsedPort == 0 )
		m_cmboPort.SetCurSel( 0 );
	else
	{
		strPort.Format( L"COM%d", m_nUsedPort );
		x = m_cmboPort.FindString( 0, strPort );
		if(x != -1)
			m_cmboPort.SetCurSel( x );
		else
			m_cmboPort.SetCurSel( 0 );
	}
	OnCbnSelchangeCmboPort(); // Set the m_nUsedPort value
	
	
}


void COPN2001_DEMODlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void COPN2001_DEMODlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR COPN2001_DEMODlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void COPN2001_DEMODlg::OnCbnSelchangeCmboPort()
{
	int nSelected = m_cmboPort.GetCurSel();
	if( nSelected == -1 )
		return;
	m_nUsedPort = (int) m_cmboPort.GetItemData( nSelected );
	
	if( m_nUsedPort > 0 )
	{
		OnBnClickedBtnClose();
		OnBnClickedBtnOpen();
	}

	
}

void COPN2001_DEMODlg::OnBnClickedBtnOpen()
{
	if(firstLoad)
	{
		firstLoad = false;
		return;
	}
	int y = m_cmboPort.GetCount();
	if(m_cmboPort.GetCount() == 0)
	{
		//Try detecting device just one more time
		::MessageBox(m_hWnd,_T("No device detected or incompatible device connected.\r\nPlease click \'OK\' and connect your OPN-2001."),_T("Error"),MB_OK|MB_ICONERROR);
		return;
	}

	int x = m_cmboPort.GetCurSel();
	if(csp2InitEx((long)m_cmboPort.GetItemData(x)) != STATUS_OK)
	{
		::MessageBox( m_hWnd, _T("Error opening serial port"), _T("Error"), MB_OK | MB_ICONERROR );
		return;
	}

	m_bComOpen = TRUE;

	csp2SetRetryCount(3);
	
	m_btnOpen.EnableWindow( FALSE );
	m_cmboPort.EnableWindow( FALSE );
	
	// Store the settings in the INI file
	CIniFile iniOpnDemo;
	iniOpnDemo.SetPathName( m_strConfigFile );
	iniOpnDemo.WriteInt( L"GLOBAL", L"USED_PORT", m_nUsedPort); 
	
	CButton* pBtn;

	pBtn = (CButton*)GetDlgItem( IDC_BTN_INTERROGATE );
	pBtn->EnableWindow( TRUE );
	pBtn = (CButton*)GetDlgItem( IDC_BTN_GET_TIME );
	pBtn->EnableWindow( TRUE );
	pBtn = (CButton*)GetDlgItem( IDC_BTN_SET_TIME );
	pBtn->EnableWindow( TRUE );
	pBtn = (CButton*)GetDlgItem( IDC_BTN_GET_BARCODE );
	pBtn->EnableWindow( TRUE );
	pBtn = (CButton*)GetDlgItem( IDC_BTN_CLEAR_BARCODE );
	pBtn->EnableWindow( TRUE );
	pBtn = (CButton*)GetDlgItem( IDC_BTN_PARAMETERS );
	pBtn->EnableWindow( TRUE );
	pBtn = (CButton*)GetDlgItem( IDC_BTN_CLOSE );
	pBtn->EnableWindow( TRUE );
	pBtn = (CButton*)GetDlgItem( IDC_CHECK_AUTO );
	pBtn->EnableWindow( TRUE );
	pBtn = (CButton*)GetDlgItem( IDC_SHOW_ALL );
	pBtn->EnableWindow( FALSE );


	m_bAutoNotClicked = TRUE;
	OnBnClickedCheckAuto();
	m_bAutoNotClicked = FALSE;
}

void COPN2001_DEMODlg::OnBnClickedBtnClose()
{
	CButton* pBtn;
	csp2Restore();
	m_btnOpen.EnableWindow();
	m_cmboPort.EnableWindow();

	m_bAutoNotClicked = TRUE;
	OnBnClickedCheckAuto();
	// disable automatic download mode
	StopAutomaticDownload();
	m_bAutoNotClicked = FALSE;
	m_bComOpen = FALSE;

	CStatic* px;
	px = (CStatic*)GetDlgItem(IDC_DSR_STATUS);
	px->SetBitmap(::LoadBitmap(AfxGetResourceHandle(), MAKEINTRESOURCE(IDB_DISABLED)));

	px = (CStatic*)GetDlgItem(IDC_DATA_STATUS);
	px->SetBitmap(::LoadBitmap(AfxGetResourceHandle(), MAKEINTRESOURCE(IDB_DISABLED)));

	pBtn = (CButton*)GetDlgItem( IDC_BTN_INTERROGATE );
	pBtn->EnableWindow( FALSE );
	pBtn = (CButton*)GetDlgItem( IDC_BTN_GET_TIME );
	pBtn->EnableWindow( FALSE );
	pBtn = (CButton*)GetDlgItem( IDC_BTN_SET_TIME );
	pBtn->EnableWindow( FALSE );
	pBtn = (CButton*)GetDlgItem( IDC_BTN_GET_BARCODE );
	pBtn->EnableWindow( FALSE );
	pBtn = (CButton*)GetDlgItem( IDC_BTN_CLEAR_BARCODE );
	pBtn->EnableWindow( FALSE );
	pBtn = (CButton*)GetDlgItem( IDC_BTN_PARAMETERS );
	pBtn->EnableWindow( FALSE );
	pBtn = (CButton*)GetDlgItem( IDC_BTN_CLOSE );
	pBtn->EnableWindow( FALSE );
	pBtn = (CButton*)GetDlgItem( IDC_CHECK_AUTO );
	pBtn->EnableWindow( FALSE );
	pBtn = (CButton*)GetDlgItem( IDC_SHOW_ALL );
	pBtn->EnableWindow( TRUE );
}


void COPN2001_DEMODlg::OnBnClickedBtnInterrogate()
{
	long lRet;
	char szSwVersion[ 9 + 1 ];
	unsigned char szDeviceID[ 9 + 1 ];
	CString strTemp;
	
	lRet = csp2Interrogate();
	if( lRet != STATUS_OK )
	{
		ShowErrorMessage( lRet );
		return;

	}

	csp2GetDeviceId( (char*)szDeviceID, 9);
	strTemp.Format( _T("%02X%02X%02X"), szDeviceID[ 5 ] & 0xFF, 
										szDeviceID[ 6 ] & 0xFF,
										szDeviceID[ 7 ] & 0xFF);
	m_statID.SetWindowText( strTemp );

	// szDeviceID need now to be converted to a real number
	csp2GetSwVersion( szSwVersion, 9 );
	strTemp.Format(_T("%S"), szSwVersion );
	m_statOSVersion.SetWindowText( strTemp );
}


//PDEV_BROADCAST_DEVICEINTERFACE 
LRESULT COPN2001_DEMODlg::OnDeviceChange( WPARAM wParam, LPARAM lParam )
{
	 if( DBT_DEVICEARRIVAL == wParam || DBT_DEVICEREMOVECOMPLETE == wParam ) 
	 {
        PDEV_BROADCAST_HDR pHdr = (PDEV_BROADCAST_HDR)lParam;
        switch( pHdr->dbch_devicetype ) 
		{
			case DBT_DEVTYP_PORT:
				PDEV_BROADCAST_PORT pDevPort = (PDEV_BROADCAST_PORT)pHdr;
				if( wcsncmp( pDevPort->dbcp_name, L"COM", 3 ) == 0 )
				{
				// Get the port number
					int nComPort = _wtoi( pDevPort->dbcp_name + 3 );
				
					if( DBT_DEVICEREMOVECOMPLETE == wParam )
					{
						if( nComPort != m_nUsedPort )
						{
						// remove the item from the list
							m_nPortArray.remove(nComPort );
							m_cmboPort.DeleteString( m_cmboPort.FindString( 0, pDevPort->dbcp_name ));
						}
						else
						{
							// The current used port needs to be changeable until it is plugged in again or 
							// another port is openened by the user

							// TODO:
						}
					}
					else
					{
						//check if it is OPN2001
						if(CSerialEnum::VerifyVersion(nComPort) || m_bShowAll)
						{
							m_nPortArray.push_back( nComPort ); // add the new port 
							m_nPortArray.sort();				// sort the list
							m_nPortArray.unique();				// all items must be unique
							int x;
							CString strTemp;
							m_itPorts = m_nPortArray.begin();
							for( x = 0; m_itPorts != m_nPortArray.end(); x++, m_itPorts++ )
							{
								if( *m_itPorts != m_cmboPort.GetItemData( x ) )
								{
									strTemp.Format( L"COM%d", *m_itPorts );
									m_cmboPort.InsertString( x, strTemp );
									m_cmboPort.SetItemData( x, *m_itPorts );
								}
							}
							if(m_cmboPort.GetCount() == 1)
							{
								m_cmboPort.SetCurSel(0);
								OnCbnSelchangeCmboPort();
							}
						}
						else
						{
							// remove the item from the list
							m_nPortArray.remove( nComPort );
							int index =  m_cmboPort.FindString( 0, pDevPort->dbcp_name );
							m_cmboPort.DeleteString(index);
						}
					}
			}
            break;
        }
    }
	return 0;
}

void COPN2001_DEMODlg::OnBnClickedBtnGetTime()
{
	unsigned char buf[10];
	CString strTemp;
	long lRet;

	if( (lRet = csp2GetTime( buf )) == STATUS_OK )
	{
		strTemp.Format( L"%d:%02d:%02d \r\n%d/%0d/%02d", buf[ 2 ],  buf[ 1 ], buf[ 0 ], buf[ 4 ], buf[ 3 ], buf[ 5 ]);
		::MessageBox( m_hWnd, strTemp, L"Information", MB_OK | MB_ICONINFORMATION );
	}
	else
	{
		ShowErrorMessage( lRet );
	}
}


void COPN2001_DEMODlg::OnBnClickedBtnSetTime()
{
	unsigned char buf[10];	
	SYSTEMTIME sysTime;
	long lRet;

	GetLocalTime( &sysTime );

	buf[0] = (unsigned char) sysTime.wSecond;	// seconds
	buf[1] = (unsigned char) sysTime.wMinute;	// minutes
	buf[2] = (unsigned char) sysTime.wHour;		// hours

	buf[3] = (unsigned char) sysTime.wDay;		// day
	buf[4] = (unsigned char) sysTime.wMonth;	// Month
	buf[5] = (unsigned char) (sysTime.wYear % 100 ); // year

	if(( lRet = csp2SetTime( buf )) == STATUS_OK )
	{
		::MessageBox( m_hWnd, L"Time is set", L"Information", MB_OK | MB_ICONINFORMATION );
	}
	else
	{
		ShowErrorMessage( lRet );
	}
}

void COPN2001_DEMODlg::OnBnClickedCheckAuto()
{
	CButton* pBtn;

	CIniFile iniOpnDemo;
	iniOpnDemo.SetPathName( m_strConfigFile );

	if( m_btnAuto.GetCheck() == 1 )
	{
		if( !m_bAutoNotClicked )
		{
			if( MessageBox( L"Auto mode will automatically retrieve all data from the OPN-2001 and simultaniously delete it from the device. This occurs immediately upon connection to the OPN-2001 or at any time data is present while connected. Data will be saved to file.\r\n\r\nDo you wish to proceed?", L"Warning", MB_YESNOCANCEL  | MB_ICONWARNING | MB_TOPMOST ) != IDYES )
			{
				m_btnAuto.SetCheck(0);
				return;
			}
		}

		// enable automatic download mode
		if( !StartAutomaticDownload())
		{
			m_btnAuto.SetCheck( FALSE );
		}
		else
		{
			// disable the other button options
			pBtn = (CButton*)GetDlgItem( IDC_BTN_INTERROGATE );
			pBtn->EnableWindow( FALSE );
			pBtn = (CButton*)GetDlgItem( IDC_BTN_GET_TIME );
			pBtn->EnableWindow( FALSE );
			pBtn = (CButton*)GetDlgItem( IDC_BTN_SET_TIME );
			pBtn->EnableWindow( FALSE );
			pBtn = (CButton*)GetDlgItem( IDC_BTN_GET_BARCODE );
			pBtn->EnableWindow( FALSE );
			pBtn = (CButton*)GetDlgItem( IDC_BTN_CLEAR_BARCODE );
			pBtn->EnableWindow( FALSE );
			pBtn = (CButton*)GetDlgItem( IDC_BTN_PARAMETERS );
			pBtn->EnableWindow( FALSE );
			pBtn = (CButton*)GetDlgItem( IDC_CHECK_SAVE );
			pBtn->EnableWindow( FALSE );
		}
	}
	else
	{
		// disable automatic download mode
		StopAutomaticDownload();
		// Enable the other button options
		pBtn = (CButton*)GetDlgItem( IDC_BTN_INTERROGATE );
		pBtn->EnableWindow();
		pBtn = (CButton*)GetDlgItem( IDC_BTN_GET_TIME );
		pBtn->EnableWindow();
		pBtn = (CButton*)GetDlgItem( IDC_BTN_SET_TIME );
		pBtn->EnableWindow();
		pBtn = (CButton*)GetDlgItem( IDC_BTN_GET_BARCODE );
		pBtn->EnableWindow();
		pBtn = (CButton*)GetDlgItem( IDC_BTN_CLEAR_BARCODE );
		pBtn->EnableWindow();
		pBtn = (CButton*)GetDlgItem( IDC_BTN_PARAMETERS );
		pBtn->EnableWindow();
		pBtn = (CButton*)GetDlgItem( IDC_CHECK_SAVE );
		pBtn->EnableWindow();
	}
	if( !m_bAutoNotClicked )
	{
		CIniFile iniOpnDemo;
		iniOpnDemo.SetPathName( m_strConfigFile );
		iniOpnDemo.WriteBool( L"GLOBAL", L"AUTO", m_btnAuto.GetCheck()); 
	}
}


BOOL COPN2001_DEMODlg::StartAutomaticDownload( void )
{
	long lRet;

	FARPROC pCallback = reinterpret_cast<FARPROC>( &csp2PollCallback );
	lRet = csp2StartPolling( pCallback /*pCallback */ );
	return ( lRet == STATUS_OK );
}

BOOL COPN2001_DEMODlg::StopAutomaticDownload( void )
{
	long lRet;

	lRet = csp2StopPolling();
	return ( lRet == STATUS_OK );
}

int __stdcall COPN2001_DEMODlg::csp2PollCallback(void)
{
	COPN2001_DEMODlg *pDlg = (COPN2001_DEMODlg*) pDlgObject;
	return pDlg->HandlePollCallback();
}

void COPN2001_DEMODlg::ConvertBarcodeToString( char *szBarcode, CString &strTemp, long lAsciiMode, long lRTC )
{
	int length;
	int nBcdLength;
	int nBarcodeType;
	char szTimeStamp[ 30 + 1]	= {0};
	CString wrapper;
	CString delimeter;
	CString time;
	CString date;
	CString tmpRTC;

	CString hour;
	CString minute;
	CString second;
	CString ampm;
	CString day;
	CString month;
	CString year;

	if(m_radioCSV.GetCheck() == TRUE)
	{
		wrapper = "\"";
		
		switch(m_cmboDelimeter.GetCurSel())
		{
			case 0:
				delimeter = ",";
				break;

			case 1:
				delimeter = ";";
				break;
		}
	} 
	else 
	{
		wrapper = "";

		switch(m_cmboDelimeter.GetCurSel())
		{
			case 0:
				delimeter = ", ";
				break;

			case 1:
				delimeter = "; ";
				break;

			case 2:
				delimeter = "\t";
				break;
		}
	}

	length = szBarcode[ 0 ];
	nBarcodeType = (long)(szBarcode[ 1 ] & 0x000000FF);
	// Clear the ouput string;
	strTemp.Empty();

	if( ( length > 0 )&& ( lAsciiMode == PARAM_ON))
	{
		nBcdLength = length + 1 - ((lRTC == PARAM_ON)?6:2);
		
		// Store the barcode
		strTemp = wrapper;
		strTemp.AppendFormat( L"%*.*S", nBcdLength, nBcdLength, szBarcode + 2 );
		strTemp.Append(wrapper);

		// Append the barcode type
		if(m_checkSymbology.GetCheck() == TRUE)
		{
			int nIndex;
			for( nIndex = 0; nIndex < MAX_BCD; nIndex++ )
			{
				if( bcodedefs[ nIndex ].lSymbol == (long) nBarcodeType )
				{
					strTemp.Append(delimeter);
					strTemp.Append(wrapper);
					strTemp.AppendFormat( L"%s", bcodedefs[ nIndex ].szSymbolName );
					strTemp.Append(wrapper);
					break;
				}
			}
			if( nIndex == MAX_BCD )
			{
				strTemp.Append(delimeter);
				strTemp.Append(wrapper);
				strTemp.Append( L"Unknown Symbology" );
				strTemp.Append(wrapper);
			}
		}

		// Append timestamp if available
		if( (m_checkDate.GetCheck() == TRUE) || (m_checkTime.GetCheck() == TRUE) )
		{
			if( lRTC == PARAM_ON)
			{
				csp2TimeStamp2Str( (unsigned char *) szBarcode + ( length - 3 ), szTimeStamp, sizeof( szTimeStamp ));
				tmpRTC.Format( L"%S", szTimeStamp );
				ManipulateTimeStamp(tmpRTC, hour, minute, second, ampm, day, month, year);

				if(m_checkTime.GetCheck() == 1)
				{
					strTemp.Append(delimeter);
					strTemp.Append(wrapper);
					if(m_radiot12.GetCheck() == 1)
					{
						strTemp.AppendFormat(L"%s:%s:%s %s", hour, minute, second, ampm);
					}
					else if(m_radiot24.GetCheck() == 1)
					{
						int tmpHour = _ttoi(hour);
						if(ampm.Mid(0, 1) == 'P')
						{
							tmpHour += 12;
							if(tmpHour == 24)
							{
								hour = "12";
							}
							else
							{
								hour.Format(L"%d", tmpHour);
							}
						}
						else if( (ampm.Mid(0, 1) == 'A') && (tmpHour == 12) )
						{
							hour = "00";
						}
						strTemp.AppendFormat(L"%s:%s:%s", hour, minute, second);
					}
					strTemp.Append(wrapper);
				}

				if(m_checkDate.GetCheck() == 1)
				{
					strTemp.Append(delimeter);
					strTemp.Append(wrapper);
					if(m_radiodUSA.GetCheck() == 1)
					{
						strTemp.AppendFormat(L"%s/%s/%s", month, day, year);
					}
					else if(m_radiodEU.GetCheck() == 1)
					{
						strTemp.AppendFormat(L"%s/%s/%s", day, month, year);
					}
					else if(m_radiodLong.GetCheck() == 1)
					{
						strTemp.AppendFormat(L"20%s-%s-%s", year, month, day);
					}
					strTemp.Append(wrapper);
				}

				//strTemp.Append(delimeter);
				//strTemp.Append(wrapper);
				//strTemp.Append(tmpRTC);
				//strTemp.AppendFormat( L"%S", szTimeStamp );
				//strTemp.Append(wrapper);
			} else {
				strTemp.Append(delimeter);
				strTemp.Append(wrapper);
				strTemp.AppendFormat(L"%S", L"Real Time Clock (RTC) Disabled");
				strTemp.Append(wrapper);
			}
		}

		//Append the Serial Number
		if (m_checkSerial.GetCheck() == TRUE)
		{
			strTemp.Append(delimeter);
			strTemp.Append(wrapper);
			strTemp.Append( gszFormattedDeviceID );
			strTemp.Append(wrapper);
		}
	}
	else
	{
		// binairy mode 
		// Not supported on OPN-2001
	}
}

void COPN2001_DEMODlg::ManipulateTimeStamp(CString& tmpRTC, CString& hour, CString& minute, CString& second, CString& ampm, CString& day, CString& month, CString& year)
{
	hour = tmpRTC.Mid( 0, 2);
	if(hour.GetAt(0) == ' ')
	{
		hour.SetAt(0, '0');
	}

	minute = tmpRTC.Mid( 3, 2);
	second = tmpRTC.Mid( 6, 2);
	ampm = tmpRTC.Mid( 9, 2);
	month = tmpRTC.Mid( 12, 2);
	if(month.GetAt(0) == ' ')
	{
		month.SetAt(0, '0');
	}

	day = tmpRTC.Mid( 15, 2);
	year = tmpRTC.Mid( 18, 2);
}

static volatile int semaphore = FALSE;	// Prevents HandlePollCallback() from being called again before the previous call has finished,
										// causing the same data to be stored in the output file twice.

int COPN2001_DEMODlg::HandlePollCallback( void )
{
	long lRet, lAsciiMode, lRTC;
	char szBarcode[ 256 + 1 ];
	char szSwVersion[ 9 + 1 ];
	char szDeviceID[ 9 + 1 ];
	int len;
	CString strTemp;
	CString strTemp2;
	TRACE(L"csp2PollCallback() \n");

	if(semaphore)
	{
		TRACE( L"HandlePollCallback() failed on semaphore\n");
		return -1L;
	}

	semaphore = TRUE;
	
	lRet = csp2ReadData();
	if( lRet > 0L )
	{
		// Get packet type (ASCII/Binary)
		lAsciiMode = csp2GetASCIIMode();

		// Get TimeStamp setting (on/off)
		lRTC = csp2GetRTCMode();

		csp2GetDeviceId( szDeviceID, 9); 

		strTemp.Format( _T("%02X%02X%02X"), szDeviceID[ 5 ] & 0xFF, 
										szDeviceID[ 6 ] & 0xFF,
										szDeviceID[ 7 ] & 0xFF);

		gszFormattedDeviceID = strTemp;
		m_statID.SetWindowText( strTemp );

		csp2GetSwVersion( szSwVersion, 9 );
		strTemp.Format(_T("%S"), szSwVersion );
		m_statOSVersion.SetWindowText( strTemp );

		// lRet contains the number of barcodes in the OPN-2001
		long lTotalBarcodes = lRet;

		m_listBcdData.ResetContent();
		strTemp.Format( L"Read %ld Barcodes", lRet );
		m_listBcdData.AddString( strTemp );
		HANDLE hFile = INVALID_HANDLE_VALUE;
		//if( m_bSaveToFile ) /*Behavior change. now always creates a file regardless of save to file check box state*/
		//{
			hFile = CreateFile( m_strSaveFile,		// path + filename 
					GENERIC_READ | GENERIC_WRITE,	// open for reading and writing
					0,								// do not share 
					NULL,							// no security 
					OPEN_ALWAYS,					// Open the file create new when not existing
					FILE_ATTRIBUTE_NORMAL,			// normal file 
					NULL);							// no attr. template 
		//}
		if( hFile != INVALID_HANDLE_VALUE )
			SetFilePointer( hFile, 0, NULL, FILE_END); // set file pointer to end for appending

		for( long lCount = 0L; lCount < lTotalBarcodes; lCount++ )
		{
			lRet = csp2GetPacket( szBarcode, lCount, sizeof( szBarcode ));
			if( lRet > 0L )
			{
				ConvertBarcodeToString( szBarcode, strTemp, lAsciiMode, lRTC );
				CString strTemp2 = strTemp;
				strTemp2.Replace(L"\t", L"    ");
				m_listBcdData.AddString( strTemp2 );
				if( hFile != INVALID_HANDLE_VALUE )
				{
					DWORD dwWr;
					len = sprintf_s( szBarcode, sizeof( szBarcode ) -1, "%S\r\n", strTemp );
					WriteFile( hFile, szBarcode, len, &dwWr, NULL );
				}
			}
		}
		if( hFile != INVALID_HANDLE_VALUE )
			CloseHandle( hFile );

		// remove the barcode data from the OPN
		csp2ClearData();
	}
	else
	{

		// Do not show error message possibly the OPN is unplugged
		TRACE( L"csp2ReadData failed!!! %ld \n", lRet);
	}

	semaphore = FALSE;

	return 0L;
}

void COPN2001_DEMODlg::OnBnClickedBtnGetBarcode()
{
	long lRet, lAsciiMode, lRTC;
	char szBarcode[ 256 + 1 ];
	int len;
	unsigned char szDeviceID[ 9 + 1 ];
	CString strTemp;
	
	lRet = csp2ReadData();
	if( lRet > 0L )
	{
		// Get Device ID and store in a global variable for use later.
		csp2GetDeviceId( (char*)szDeviceID, 9);
		strTemp.Format( _T("%02X%02X%02X"), szDeviceID[ 5 ] & 0xFF, 
											szDeviceID[ 6 ] & 0xFF,
											szDeviceID[ 7 ] & 0xFF);
		gszFormattedDeviceID = strTemp;
		strTemp.Empty();

		// Get packet type (ASCII/Binary)
		lAsciiMode = csp2GetASCIIMode();

		// Get TimeStamp setting (on/off)
		lRTC = csp2GetRTCMode();

		// lRet contains the number of barcodes in the OPN-2001
		long lTotalBarcodes = lRet;

		m_listBcdData.ResetContent();
		strTemp.Format( L"Read %ld Barcodes", lRet );
		m_listBcdData.AddString( strTemp );

		HANDLE hFile = INVALID_HANDLE_VALUE;
		if( m_bSaveToFile )
		{
			//CString FileName;
			/*CFileDialog FileDlg(FALSE,_T(".txt"),NULL,0,_T("Text Files(*.txt)|*.txt||"));
			if(FileDlg.DoModal() == IDOK)
			{
				m_strSaveFile = FileDlg.GetFileName();
			}*/

			hFile = CreateFile( m_strSaveFile,		// path + filename 
					GENERIC_READ | GENERIC_WRITE,	// open for reading and writing
					0,								// do not share 
					NULL,							// no security 
					OPEN_ALWAYS,					// Open the file create new when not existing
					FILE_ATTRIBUTE_NORMAL,			// normal file 
					NULL);							// no attr. template 

			if(hFile == INVALID_HANDLE_VALUE )
			{
				ShowErrorMessage(WRITE_FILE_ERROR);
			}
		}
		if( hFile != INVALID_HANDLE_VALUE )
			SetFilePointer( hFile, 0, NULL, FILE_END); // set file pointer to end for appending

		for( long lCount = 0L; lCount < lTotalBarcodes; lCount++ )
		{
			lRet = csp2GetPacket( szBarcode, lCount, sizeof( szBarcode ));
			if( lRet > 0L )
			{
				ConvertBarcodeToString( szBarcode, strTemp, lAsciiMode, lRTC );
				CString strTemp2 = strTemp;
				strTemp2.Replace(L"\t", L"    ");
				m_listBcdData.AddString( strTemp2 );
				if( hFile != INVALID_HANDLE_VALUE )
				{
					DWORD dwWr;
					len = sprintf_s( szBarcode, sizeof( szBarcode ) -1, "%S\r\n", strTemp );
					WriteFile( hFile, szBarcode, len, &dwWr, NULL );
				}
			}
		}
		if( hFile != INVALID_HANDLE_VALUE )
			CloseHandle( hFile );
	}
	else if( lRet == 0L )
	{
		m_listBcdData.ResetContent();
		m_listBcdData.AddString( L"No barcodes available" );
	}
	else
	{
		ShowErrorMessage( lRet );
	}
}

void COPN2001_DEMODlg::OnBnClickedBtnClearBarcode()
{
	long lRet;

	//MessageBox( strMessage, L"Error", MB_OK | MB_ICONERROR | MB_TOPMOST );
	if( MessageBox( L"This option will delete all data from the OPN-2001. Displayed data and data saved to file is not affected. This action is not reversible.\r\n\r\nDo you wish to proceed?", L"Warning", MB_YESNOCANCEL  | MB_ICONWARNING | MB_TOPMOST ) == IDYES )
	{
		lRet = csp2ClearData();
		if( lRet != STATUS_OK )
		{
			ShowErrorMessage( lRet );
		}
	}
}

void COPN2001_DEMODlg::OnBnClickedBtnParameters()
{
	if( m_btnOpen.IsWindowEnabled() )
	{
		// Show some message that there is no connection to the OPN
		return; 
	}
	
	long lRet = csp2Interrogate();
	if(lRet != STATUS_OK)
	{
		ShowErrorMessage( lRet );
		return;
		
	}
	CDlgParameters dlg;
	dlg.DoModal();
}

void COPN2001_DEMODlg::OnBnClickedCheckSave()
{
	CButton *pBtn = (CButton*)GetDlgItem( IDC_CHECK_SAVE );
	m_bSaveToFile = pBtn->GetCheck();

	CIniFile iniOpnDemo;
	iniOpnDemo.SetPathName( m_strConfigFile );

	// Store the settings in the INI file
	iniOpnDemo.SetPathName( m_strConfigFile );
	m_bSaveToFile = iniOpnDemo.WriteBool( L"GLOBAL", L"SAVEFILE", m_bSaveToFile ); 
}

void COPN2001_DEMODlg::OnClose()
{
	CDialog::OnClose();
	EndDialog( IDOK );
}

void COPN2001_DEMODlg::OnOK()
{
}

void COPN2001_DEMODlg::OnCancel()
{
}

void COPN2001_DEMODlg::ShowErrorMessage( long lErrorCode )
{
	CString strMessage;
	bool needDisconnect = false;

	switch( lErrorCode )
	{
	case STATUS_OK:
		strMessage = L"Status OK";
		break;
	case COMMUNICATIONS_ERROR:
		strMessage = L"Communication error!";
		needDisconnect = true;
		break;
	case BAD_PARAM:       
		strMessage = L"Bad parameter!";
		break;
	case SETUP_ERROR:
		strMessage = L"Setup error!";
		break;
	case INVALID_COMMAND_NUMBER:
		strMessage = L"Invalid command number!";
		break;
	case COMMAND_LRC_ERROR:
		strMessage = L"Checksum error!";
		break;
	case RECEIVED_CHARACTER_ERROR:
		strMessage = L"Wrong character received!";
		break;
	case GENERAL_ERROR:
		strMessage = L"General error!";
		break;
	case FILE_NOT_FOUND:
		strMessage = L"File not found!";
		break;
	case ACCESS_DENIED:
		strMessage = L"Access denied!";
		break;
	case WRITE_FILE_ERROR:
		strMessage = L"Couldn't open file for writing";
		break;
	default:
		strMessage = L"Unknow error!!!";
		break;
	}
	MessageBox( strMessage, L"Error", MB_OK | MB_ICONERROR | MB_TOPMOST );
	if(needDisconnect)
	{
		OnBnClickedBtnClose();
		needDisconnect = false;
	}
}

void COPN2001_DEMODlg::OnBnClickedBtnAbout()
{
	CAboutDlg dlg;
	dlg.DoModal();
}

void COPN2001_DEMODlg::InitFormatControls()
{
	CIniFile iniOpnDemo;
	iniOpnDemo.SetPathName( m_strConfigFile );

	m_checkSymbology.SetCheck( iniOpnDemo.ReadInt( L"FORMAT", L"SHOW_SYMBOLOGY", TRUE ) );
	m_checkTime.SetCheck( iniOpnDemo.ReadInt( L"FORMAT", L"SHOW_TIME", TRUE ) );
	m_checkDate.SetCheck( iniOpnDemo.ReadInt( L"FORMAT", L"SHOW_DATE", TRUE ) );
	m_checkSerial.SetCheck( iniOpnDemo.ReadInt( L"FORMAT", L"SHOW_SERIAL", TRUE ) );

	if(m_checkTime.GetCheck() == 0)
	{
		m_radiot12.EnableWindow( FALSE );
		m_radiot24.EnableWindow( FALSE );
	}
	if(m_checkDate.GetCheck() == 0)
	{
		m_radiodUSA.EnableWindow( FALSE );
		m_radiodEU.EnableWindow( FALSE );
		m_radiodLong.EnableWindow( FALSE );
	}

	m_radioText.SetCheck( iniOpnDemo.ReadInt( L"FORMAT", L"FORMAT_IS_TEXT", TRUE ) );
	m_radioCSV.SetCheck( iniOpnDemo.ReadInt( L"FORMAT", L"FORMAT_IS_CSV", FALSE ) );

	m_radiot12.SetCheck( iniOpnDemo.ReadInt( L"FORMAT", L"TIME_IS_12", TRUE ) );
	m_radiot24.SetCheck( iniOpnDemo.ReadInt( L"FORMAT", L"TIME_IS_24", FALSE ) );

	m_radiodUSA.SetCheck( iniOpnDemo.ReadInt( L"FORMAT", L"DATE_IS_USA", TRUE ) );
	m_radiodEU.SetCheck( iniOpnDemo.ReadInt( L"FORMAT", L"DATE_IS_EU", FALSE ) );
	m_radiodLong.SetCheck( iniOpnDemo.ReadInt( L"FORMAT", L"DATE_IS_LONG", FALSE ) );
	
	m_cmboDelimeter.AddString(L"Comma");
	m_cmboDelimeter.AddString(L"Semicolon");

	if(m_radioCSV.GetCheck() != TRUE)
	{
		m_cmboDelimeter.AddString(L"Tab");
	}

	m_cmboDelimeter.SetCurSel( iniOpnDemo.ReadInt( L"FORMAT", L"DELIMETER", 0 ) );
	
	m_strSaveFile = szModulePath;
	if(m_radioText.GetCheck() == 1)
	{
		m_strSaveFile += L"\\Barcodes.txt";
	} else {
		m_strSaveFile += L"\\Barcodes.csv";
	}

	m_strSaveFile = iniOpnDemo.ReadString( L"GLOBAL", L"SAVE_FILE_PATH", m_strSaveFile );

	strCurSavePath = m_strSaveFile;
	strCurSaveFileName = m_strSaveFile;
	
	LPWSTR m_tmp = strCurSavePath.GetBuffer(1024);
	PathRemoveFileSpec( m_tmp );
	strCurSavePath.ReleaseBuffer();

	LPWSTR m_tmp2 = strCurSaveFileName.GetBuffer(1024);
	PathStripPath( m_tmp2 );
	strCurSaveFileName.ReleaseBuffer();
	

}

void COPN2001_DEMODlg::OnBnClickedCheckSymbology()
{
	CIniFile iniOpnDemo;
	iniOpnDemo.SetPathName( m_strConfigFile );
	iniOpnDemo.WriteInt( L"FORMAT", L"SHOW_SYMBOLOGY", m_checkSymbology.GetCheck() );
}

void COPN2001_DEMODlg::OnBnClickedCheckSerial()
{
	CIniFile iniOpnDemo;
	iniOpnDemo.SetPathName( m_strConfigFile );
	iniOpnDemo.WriteInt( L"FORMAT", L"SHOW_SERIAL", m_checkSerial.GetCheck() );
}

void COPN2001_DEMODlg::OnBnClickedCheckTime()
{
	CIniFile iniOpnDemo;
	iniOpnDemo.SetPathName( m_strConfigFile );
	iniOpnDemo.WriteInt( L"FORMAT", L"SHOW_TIME", m_checkTime.GetCheck() );

	if(m_checkTime.GetCheck() == 1)
	{
		m_radiot12.EnableWindow( TRUE );
		m_radiot24.EnableWindow( TRUE );
	}
	else
	{
		m_radiot12.EnableWindow( FALSE );
		m_radiot24.EnableWindow( FALSE );
	}
}

void COPN2001_DEMODlg::OnBnClickedCheckDate()
{
	CIniFile iniOpnDemo;
	iniOpnDemo.SetPathName( m_strConfigFile );
	iniOpnDemo.WriteInt( L"FORMAT", L"SHOW_DATE", m_checkDate.GetCheck() );
	
	if(m_checkDate.GetCheck() == 1)
	{
		m_radiodUSA.EnableWindow( TRUE );
		m_radiodEU.EnableWindow( TRUE );
		m_radiodLong.EnableWindow( TRUE );
	}
	else
	{
		m_radiodUSA.EnableWindow( FALSE );
		m_radiodEU.EnableWindow( FALSE );
		m_radiodLong.EnableWindow( FALSE );
	}
}

void COPN2001_DEMODlg::OnBnClickedRadioFormatText()
{
	CIniFile iniOpnDemo;
	iniOpnDemo.SetPathName( m_strConfigFile );
	iniOpnDemo.WriteInt( L"FORMAT", L"FORMAT_IS_TEXT", m_radioText.GetCheck() );
	iniOpnDemo.WriteInt( L"FORMAT", L"FORMAT_IS_CSV", !m_radioText.GetCheck() );

	m_cmboDelimeter.AddString(L"Tab");
	m_cmboDelimeter.SetCurSel(0);

	LPWSTR m_tmp = m_strSaveFile.GetBuffer(1024);
	PathRenameExtension( m_tmp, L".txt");
	m_strSaveFile.ReleaseBuffer();

	iniOpnDemo.WriteString( L"GLOBAL", L"SAVE_FILE_PATH", m_strSaveFile);
}

void COPN2001_DEMODlg::OnBnClickedRadioFormatCSV()
{
	CIniFile iniOpnDemo;
	iniOpnDemo.SetPathName( m_strConfigFile );
	iniOpnDemo.WriteInt( L"FORMAT", L"FORMAT_IS_CSV", m_radioCSV.GetCheck() );
	iniOpnDemo.WriteInt( L"FORMAT", L"FORMAT_IS_TEXT", !m_radioCSV.GetCheck() );

	m_cmboDelimeter.DeleteString(2);
	m_cmboDelimeter.SetCurSel(0);

	LPWSTR m_tmp = m_strSaveFile.GetBuffer(1024);
	PathRenameExtension( m_tmp, L".csv");
	m_strSaveFile.ReleaseBuffer();

	iniOpnDemo.WriteString( L"GLOBAL", L"SAVE_FILE_PATH", m_strSaveFile);
}

void COPN2001_DEMODlg::OnBnClickedRadioTime12()
{
	CIniFile iniOpnDemo;
	iniOpnDemo.SetPathName( m_strConfigFile );
	iniOpnDemo.WriteInt( L"FORMAT", L"TIME_IS_12", m_radiot12.GetCheck() );
	iniOpnDemo.WriteInt( L"FORMAT", L"TIME_IS_24", !m_radiot12.GetCheck() );
}

void COPN2001_DEMODlg::OnBnClickedRadioTime24()
{
	CIniFile iniOpnDemo;
	iniOpnDemo.SetPathName( m_strConfigFile );
	iniOpnDemo.WriteInt( L"FORMAT", L"TIME_IS_24", m_radiot24.GetCheck() );
	iniOpnDemo.WriteInt( L"FORMAT", L"TIME_IS_12", !m_radiot24.GetCheck() );
}

void COPN2001_DEMODlg::OnBnClickedRadioDateUSA()
{
	CIniFile iniOpnDemo;
	iniOpnDemo.SetPathName( m_strConfigFile );
	iniOpnDemo.WriteInt( L"FORMAT", L"DATE_IS_USA", m_radiodUSA.GetCheck() );
	iniOpnDemo.WriteInt( L"FORMAT", L"DATE_IS_EU", !m_radiodUSA.GetCheck() );
	iniOpnDemo.WriteInt( L"FORMAT", L"DATE_IS_LONG", !m_radiodUSA.GetCheck() );
}

void COPN2001_DEMODlg::OnBnClickedRadioDateEU()
{
	CIniFile iniOpnDemo;
	iniOpnDemo.SetPathName( m_strConfigFile );
	iniOpnDemo.WriteInt( L"FORMAT", L"DATE_IS_EU", m_radiodEU.GetCheck() );
	iniOpnDemo.WriteInt( L"FORMAT", L"DATE_IS_USA", !m_radiodEU.GetCheck() );
	iniOpnDemo.WriteInt( L"FORMAT", L"DATE_IS_LONG", !m_radiodEU.GetCheck() );
}

void COPN2001_DEMODlg::OnBnClickedRadioDateLong()
{
	CIniFile iniOpnDemo;
	iniOpnDemo.SetPathName( m_strConfigFile );
	iniOpnDemo.WriteInt( L"FORMAT", L"DATE_IS_LONG", m_radiodLong.GetCheck() );
	iniOpnDemo.WriteInt( L"FORMAT", L"DATE_IS_USA", !m_radiodLong.GetCheck() );
	iniOpnDemo.WriteInt( L"FORMAT", L"DATE_IS_EU", !m_radiodLong.GetCheck() );
}

void COPN2001_DEMODlg::OnCbnSelChangeComboDelimeter()
{
	CIniFile iniOpnDemo;
	iniOpnDemo.SetPathName( m_strConfigFile );
	iniOpnDemo.WriteInt( L"FORMAT", L"DELIMETER", m_cmboDelimeter.GetCurSel() );
}

void COPN2001_DEMODlg::OnBnClickedBtnBrowse()
{
	INT_PTR lRet;
	CString tmp;

	if(m_radioText.GetCheck() == TRUE)
	{
		CFileDialog FileDlg(FALSE,_T(".txt"),strCurSaveFileName,0,_T("Text Files(*.txt)|*.txt||"));
		lRet = FileDlg.DoModal();
		tmp = FileDlg.GetPathName();
	}
	else if(m_radioCSV.GetCheck() == TRUE)
	{
		CFileDialog FileDlg(FALSE,_T(".csv"),strCurSaveFileName,0,_T("Comma Seperated Values (*.csv)|*.csv||"));
		lRet = FileDlg.DoModal();
		tmp = FileDlg.GetPathName();
	}
	if(lRet == IDOK)
	{
		CIniFile iniOpnDemo;

		m_strSaveFile = tmp;

		iniOpnDemo.SetPathName( m_strConfigFile );
		iniOpnDemo.WriteString( L"GLOBAL", L"SAVE_FILE_PATH", m_strSaveFile);
		
		strCurSavePath = m_strSaveFile;
		strCurSaveFileName = m_strSaveFile;
		
		LPWSTR m_tmp = strCurSavePath.GetBuffer(1024);
		PathRemoveFileSpec( m_tmp );
		strCurSavePath.ReleaseBuffer();

		LPWSTR m_tmp2 = strCurSaveFileName.GetBuffer(1024);
		PathStripPath( m_tmp2 );
		strCurSaveFileName.ReleaseBuffer();
	}
}

void COPN2001_DEMODlg::OnBnClickedShowAll()
{
	CButton *pBtn = (CButton*)GetDlgItem( IDC_SHOW_ALL );
	m_bShowAll = pBtn->GetCheck();

	CIniFile iniOpnDemo;
	iniOpnDemo.SetPathName( m_strConfigFile );

	// First find the available serial ports
	CSerialEnum::GetOPN01ConnectedSerialPorts( m_nPortArray, m_bShowAll );
	m_nPortArray.sort();
	// Fill the combobox
	m_cmboPort.ResetContent(); // Clear the list in the combobox;
	
	CString strPort;
	int x;
	for( m_itPorts = m_nPortArray.begin(), x = 0; m_itPorts != m_nPortArray.end(); m_itPorts++, x++ )
	{
		strPort.Format(_T("COM%d"), *m_itPorts );
		m_cmboPort.AddString( strPort );
		m_cmboPort.SetItemData( x, *m_itPorts );
	}
	if( m_nUsedPort == 0 )
		m_cmboPort.SetCurSel( 0 );
	else
	{
		strPort.Format( L"COM%d", m_nUsedPort );
		x = m_cmboPort.FindString( 0, strPort );
		if(x != -1)
			m_cmboPort.SetCurSel( x );
		else
			m_cmboPort.SetCurSel( 0 );
	}
	
	// Store the settings in the INI file
	iniOpnDemo.SetPathName( m_strConfigFile );
	m_bShowAll = iniOpnDemo.WriteBool( L"GLOBAL", L"SHOWALL", m_bShowAll ); 

}

void COPN2001_DEMODlg::OnTimer(UINT_PTR nIDEvent)
{
	CDialog::OnTimer(nIDEvent);

	if(m_bComOpen)
	{
		CStatic* dsr = (CStatic*)GetDlgItem(IDC_DSR_STATUS);
	
		if(csp2GetDSR())
		{
			dsr->SetBitmap(::LoadBitmap(AfxGetResourceHandle(), MAKEINTRESOURCE(IDB_CONNECTED)));
		}
		else
		{
			dsr->SetBitmap(::LoadBitmap(AfxGetResourceHandle(), MAKEINTRESOURCE(IDB_ERROR)));
		}

		CStatic* cts = (CStatic*)GetDlgItem(IDC_DATA_STATUS);

		if(csp2GetCTS())
		{
			cts->SetBitmap(::LoadBitmap(AfxGetResourceHandle(), MAKEINTRESOURCE(IDB_CONNECTED)));
		}
		else
		{
			cts->SetBitmap(::LoadBitmap(AfxGetResourceHandle(), MAKEINTRESOURCE(IDB_DISCONNECTED)));
		}
	}
}
